#!/usr/local/bin/perl -w

# this program finds the average of the columns

#------------------------ Main code ---------------------



if( $#ARGV >= 2) {
open(INPUT,$ARGV[0]) || die " cannot open $ARGV[0] for input";
open(OUTPUT,">>".$ARGV[1]) || die "cannot open $ARGV[1] for output";
$numColumn = $ARGV[2];
}
else
{
die "Usage: <input file> <output file> <number of columns to average>"
}
$numRec=0;


# This file assumes that the the columns to average are all real numbers of form (\d+[.\d+]*)
$pattern='(\\S+)';

$temp = 0;
while( $temp < $numColumn ) {
    $temp++;
    $pattern=$pattern.' (\\d+[.\\d+]*)';

}
#$pattern=$pattern;


while(<INPUT>)
{
    if(/^END_REC/o)
    {
	$numRec++;
    }
     elsif(/^$pattern/)
    {

	$columnHead{$1}= 1;
	$temp = 2;
	$numColumnPlus=$numColumn + 1;
	while($temp <= $numColumnPlus)
	{
	    if(defined($column{"$1:$temp"}) ) 
	    {
		$column{"$1:$temp"} += ${$temp} ;
	    } 
	     else {
	        $column{"$1:$temp"}= ${$temp};
             }
    
            $temp++;

	 }

    }

   else
    { 
 #   print "HERE $_";
   }

}



#Compute the averages

@keyList = keys(%columnHead);

foreach $i (@keyList) {
    $temp = 2;
    $numColumnPlus = $numColumn + 1;
    print OUTPUT "$i";
    while($temp <= $numColumnPlus)
{
    if( defined( $column{"$i:$temp"}) ) 
      {
	$column{"$i:$temp"} /= $numRec ;
      } 
      else {
        $column{"$i:$temp"}= 0;
      }
    $outVal =  $column{"$i:$temp"};
    print OUTPUT " $outVal";
      $temp++;
   }
   print OUTPUT "\n"; 
} 

close(INPUT);
close(OUTPUT);
exit(0);

